<?php
/*
Simple:Press
File Uploader plugin ahah routine for management functions
$LastChangedDate: 2013-02-16 16:20:30 -0700 (Sat, 16 Feb 2013) $
$Rev: 9848 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

sp_forum_api_support();

if (!isset($_GET['action'])) die();
$action = $_GET['action'];

if ($action == 'list-attachments') {
    global $spThisUser;

    $pid = sp_esc_int($_GET['pid']);
	$attachments = spdb_table(SPPOSTATTACHMENTS, "post_id=$pid");

    if ((!$spThisUser->admin && !$spThisUser->moderator) || empty($attachments)) die();

	$post = spdb_table(SFPOSTS, "post_id=".$attachments[0]->post_id, 'row');
	$topic = spdb_table(SFTOPICS, "topic_id=".$post->topic_id, 'row');
	$forum = spdb_table(SFFORUMS, "forum_id=".$topic->forum_id, 'row');
?>
	<div id="spMainContainer" class="spForumToolsPopup">
		<div class="spForumToolsHeader">
			<div class="spForumToolsHeaderTitle"><?php echo __('Select attachment(s) you want to remove from this post', 'sp-plup').':'; ?></div>
		</div>
		<form action="<?php echo sp_build_url($forum->forum_slug, $topic->topic_slug, '', $post->post_id, $post->post_index); ?>" method="post" name="removepostattachments">
			<div class="spCenter">
				<br /><?php echo sp_plupload_render_attachment_list($attachments); ?><br /><br />
				<input type="submit" class="spSubmit" name="removeattachments" value="<?php echo esc_attr(__('Remove Post Attachments', 'sp-plup')) ?>" />
				<input type="button" class="spSubmit" name="cancel" value="<?php echo esc_attr(__('Cancel', 'sp-plup')) ?>" onclick="jQuery('#dialog').dialog('close');" />
                <br /><br /><p><?php echo __('This will remove the attachment, but you will have to manually remove from the post content the image tag', 'sp-plup'); ?></p>
			</div>
		</form>
	</div>
<?php

   die();
}

if ($action == 'remove-attachment') {
    $userid = sp_esc_int($_GET['user']);
    $type = sp_esc_str($_GET['type']);
    $node = sp_esc_str($_GET['node']);
    if (empty($type) || empty($node) || empty($userid)) die();

    $user = sp_get_user($userid);
    if (empty($user)) die();

    global $plup;
    sp_plupload_config($user);

    $sfconfig = sp_get_option('sfconfig');

    # create slug to user uloads directory
    $user_slug = (!empty($user->ID)) ? sp_create_slug($user->user_login, false) : '';
    $path = $user_slug.'/'.$node;

    # set up paths to the stored files
    $file = basename($path);
    $dbpath = str_replace('/'.$file, '', $path).'/';
    $fullpath = $plup['basepath'][$type].$node;
    $thumbpath = SF_STORE_DIR.'/'.$sfconfig["$type-uploads"].'/'.$dbpath.'_thumbs/_'.$file;

    # now delete file
    if (file_exists($fullpath)) @unlink($fullpath);
    if ($type == 'image' && file_exists($thumbpath)) @unlink($thumbpath);

    # lets get the attachment db info
    $attachment = spdb_select('row', 'SELECT * FROM '.SPPOSTATTACHMENTS." WHERE path='$dbpath' AND filename='$file'");

    # remove from post content
    if ($type != 'file') {
        $post_content = spdb_select('var', 'SELECT post_content FROM '.SFPOSTS." WHERE post_id=$attachment->post_id");
        $src = untrailingslashit(SF_STORE_URL.'/'.$sfconfig["$type-uploads"].'/'.$dbpath.$file);
        if ($type == 'image') {
            # check for image attachment
            $match = '#<img[^>]+src[^>]+'.$src.'+[^>]+>#';
            $replace = apply_filters('sph_attachment_removed_image', '<p class="spImageRemoved">'.__('*** Image attachment removed from post content ***', 'sp-plup').'</p>', $attachment->post_id, $attachment->attachment_id);
            $post_content = preg_replace($match, $replace, $post_content);
        } else {
            # check for audio attachment
            $match = '#<audio[^>]+src[^>]+'.$src.'+[^>]+>#';
            $replace = apply_filters('sph_attachment_removed_media', '<p class="spImageRemoved">'.__('*** Media attachment removed from post content ***', 'sp-plup').'</p>', $attachment->post_id, $attachment->attachment_id);
            $post_content = preg_replace($match, $replace, $post_content);

            # check for video attachment
            $match = '#<video[^>]+src[^>]+'.$src.'+[^>]+>#';
            $replace = apply_filters('sph_attachment_removed_media', '<p class="spImageRemoved">'.__('*** Media attachment removed from post content ***', 'sp-plup').'</p>', $attachment->post_id, $attachment->attachment_id);
            $post_content = preg_replace($match, $replace, $post_content);
        }
       	spdb_query('UPDATE '.SFPOSTS." SET post_content='$post_content' WHERE post_id=$attachment->post_id");
    }
    # remove from db
   	spdb_query('DELETE FROM '.SPPOSTATTACHMENTS." WHERE attachment_id=$attachment->attachment_id");

    die();
}

if ($action == 'remove-photo') {
    $uid = sp_esc_int($_GET['uid']);
    $fid = sp_esc_str($_GET['fid']);
    $fid = urldecode($fid);
    $photos = get_user_meta($uid, 'sp_profile_photos', true);
    if ($photos) {
        foreach ($photos as $index => $photo) {
            if ($photo['file'] == $fid) {
                $file = $photo['loc'].$photo['file'];
                if (file_exists($file)) @unlink($file);
                $thumb = $photo['loc'].'_thumbs/_'.$photo['file'];
                if (file_exists($thumb)) @unlink($thumb);

                unset($photos[$index]);
                $newPhotos = array_values($photos);
                update_user_meta($uid, 'sp_profile_photos', $newPhotos);
                break;
            }
        }
    }
?>
<script type="text/javascript">
	jQuery(document).ready(function() {
        spjSetProfileDataHeight();
	})
</script>
<?php
}

die();

?>